<!--
  ~ Copyright (c) 2008, Anastasios Skarlatidis
  ~
  ~ NCSR "Demokritos"
  ~ Institute of Informatics & Telecommunications
  ~ SKEL Laboratory
  ~
  ~ University of Aegean
  ~ ICSE Department
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU General Public License
  ~ along with this program.  If not, see <http://www.gnu.org/licenses/
  -->

<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:xs="http://www.w3.org/2001/XMLSchema">

    <xsl:output method="text" encoding="UTF-8"/>
    <xsl:strip-space elements="*"/>
    <xsl:template match="/dataset">

<!--Object::Appearence-->
<xsl:result-document href="AppearenceIndv.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(objectlist/object) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="objectlist/object">
                <xsl:variable as="xs:integer" name="objectID" select="@id"/>
holdsAt( orientation( id<xsl:value-of select="$objectID"/> )=<xsl:value-of select="orientation"/>, <xsl:value-of select="$startTime"/>  ). holdsAt( appearance( id<xsl:value-of select="$objectID"/> )=<xsl:value-of select="appearance"/>,  <xsl:value-of select="$startTime"/> ).<xsl:text/>
            </xsl:for-each>
 </xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Object::Movement-->
<xsl:result-document href="MovementIndv.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(objectlist/object) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="objectlist/object">
                <xsl:variable  name="xc" select="box/@xc"/>
                <xsl:variable  name="yc" select="box/@yc"/>
                <xsl:variable as="xs:integer" name="objectID" select="@id"/>
                <xsl:for-each select="hypothesislist/hypothesis">
happens( <xsl:value-of select="replace(movement,' ', '_')"/>( id<xsl:value-of select="$objectID"/> ), <xsl:value-of select="$startTime"/> ). holdsAt( coord( id<xsl:value-of select="$objectID"/> )=( <xsl:value-of select="$xc"/>, <xsl:value-of select="$yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
                </xsl:for-each>
            </xsl:for-each>
    </xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Object::Situation-->
<xsl:result-document href="SituationIndv.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(objectlist/object) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="objectlist/object">
                <xsl:variable  name="xc" select="box/@xc"/>
                <xsl:variable  name="yc" select="box/@yc"/>
                <xsl:variable as="xs:integer" name="objectID" select="@id"/>
                <xsl:for-each select="hypothesislist/hypothesis">
happens( <xsl:value-of select="replace(situation,' ', '_')"/>( id<xsl:value-of select="$objectID"/> ), <xsl:value-of select="$startTime"/> ). holdsAt( coord( id<xsl:value-of select="$objectID"/> )=( <xsl:value-of select="$xc"/>, <xsl:value-of select="$yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
                </xsl:for-each>
            </xsl:for-each>
    </xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Object::Context-->
<xsl:result-document href="ContextIndv.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(objectlist/object) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="objectlist/object">
                <xsl:variable  name="xc" select="box/@xc"/>
                <xsl:variable  name="yc" select="box/@yc"/>
                <xsl:variable as="xs:integer" name="objectID" select="@id"/>
                <xsl:for-each select="hypothesislist/hypothesis">
happens( <xsl:value-of select="replace(context,' ', '_')"/>( id<xsl:value-of select="$objectID"/> ), <xsl:value-of select="$startTime"/> ). holdsAt( coord( id<xsl:value-of select="$objectID"/> )=( <xsl:value-of select="$xc"/>, <xsl:value-of select="$yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
                </xsl:for-each>
            </xsl:for-each>
    </xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>


<!--Group-->

        
<!--Group::Appearence-->
<xsl:result-document href="AppearenceGrp.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(grouplist/group) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="grouplist/group">
holdsAt( orientation( grp_ID<xsl:value-of select="@id"/> )=<xsl:value-of select="orientation"/>, <xsl:value-of select="$startTime"/>  ). holdsAt( appearance( grp_ID<xsl:value-of select="@id"/> )=<xsl:value-of select="appearance"/>,  <xsl:value-of select="$startTime"/> ).<xsl:text/>
            </xsl:for-each>
</xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Group::Movement-->
<xsl:result-document href="MovementGrp.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(grouplist/group) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="grouplist/group">
                <xsl:variable  name="obj_xc" select="box/@xc"/>
                <xsl:variable  name="obj_yc" select="box/@yc"/>
                <xsl:variable name="idListF" >
                    <xsl:for-each select="tokenize(members, ',')">id<xsl:value-of select="."/>, </xsl:for-each>
                </xsl:variable>
happens( <xsl:value-of select="replace(hypothesislist/hypothesis/movement, ' ', '_')"/>( grp_ID<xsl:value-of select="@id"/>, [ <xsl:value-of select="substring($idListF, 0, string-length($idListF)-1)"/> ]), <xsl:value-of select="$startTime"/>). holdsAt( coord( grp_ID<xsl:value-of select="@id"/> )=( <xsl:value-of select="$obj_xc"/>, <xsl:value-of select="$obj_yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
            </xsl:for-each>
</xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Group::Situation-->
<xsl:result-document href="SituationGrp.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(grouplist/group) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="grouplist/group">
                <xsl:variable  name="obj_xc" select="box/@xc"/>
                <xsl:variable  name="obj_yc" select="box/@yc"/>
                <xsl:variable name="idListF" >
                    <xsl:for-each select="tokenize(members, ',')">id<xsl:value-of select="."/>, </xsl:for-each>
                </xsl:variable>
happens( <xsl:value-of select="replace(hypothesislist/hypothesis/situation, ' ', '_')"/>( grp_ID<xsl:value-of select="@id"/>, [ <xsl:value-of select="substring($idListF, 0, string-length($idListF)-1)"/> ]), <xsl:value-of select="$startTime"/>). holdsAt( coord( grp_ID<xsl:value-of select="@id"/> )=( <xsl:value-of select="$obj_xc"/>, <xsl:value-of select="$obj_yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
            </xsl:for-each>
</xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

<!--Group::Context-->
<xsl:result-document href="ContextGrp.pl">
<!--Frame-->
        <xsl:for-each select="/dataset/frame">
            <xsl:variable as="xs:integer" name="frameNumber" select="@number"/>

<xsl:if test="count(grouplist/group) > 0">
<xsl:text>
</xsl:text>
% Frame number: <xsl:value-of select="$frameNumber"/>
</xsl:if>
            <xsl:variable as="xs:integer" name="startTime" select="$frameNumber * 40"/>
            <xsl:for-each select="grouplist/group">
                <xsl:variable  name="obj_xc" select="box/@xc"/>
                <xsl:variable  name="obj_yc" select="box/@yc"/>
                <xsl:variable name="idListF" >
                    <xsl:for-each select="tokenize(members, ',')">id<xsl:value-of select="."/>, </xsl:for-each>
                </xsl:variable>
happens( <xsl:value-of select="replace(hypothesislist/hypothesis/context, ' ', '_')"/>( grp_ID<xsl:value-of select="@id"/>, [ <xsl:value-of select="substring($idListF, 0, string-length($idListF)-1)"/> ]), <xsl:value-of select="$startTime"/>). holdsAt( coord( grp_ID<xsl:value-of select="@id"/> )=( <xsl:value-of select="$obj_xc"/>, <xsl:value-of select="$obj_yc"/> ), <xsl:value-of select="$startTime"/> ).<xsl:text/>
            </xsl:for-each>
</xsl:for-each>
<xsl:text>

</xsl:text>
</xsl:result-document>

    </xsl:template>
</xsl:stylesheet>