#!/bin/bash

#
# ========== Settings ==========
#
x86_64='true'

if [ $x86_64 = 'true' ]; then
  LOCAL_STACK=256m
  GLOBAL_STACK=512m
else
  LOCAL_STACK=128m
  GLOBAL_STACK=128m
fi

SOURCE_DATASET="../source"
SRC_CAVIAR=$SOURCE_DATASET"/caviar"
TRG_CAVIAR="./mln/caviar"

echo "SOURCE_DATASET="$SOURCE_DATASET
echo "SRC_CAVIAR="$SRC_CAVIAR
echo "SRC_CAVIAR_ABRUPT="$SRC_CAVIAR_ABRUPT
# ============================

#
# ========= Functions ==========
#
numOfCores(){
  return `grep processor /proc/cpuinfo | wc -l`
}

execParser(){
  echo "Exec: prolog -f $1 -t \"make([$2]).\""
  echo ""
  nice prolog -f $1 -t "make([$2])."
}
# ============================



if [ ! -d "./mln" ]; then
  mkdir "./mln"
  mkdir "./mln/caviar"
else
  list=`ls ./mln`
  if [ -n "${list}" ]; then
    echo "Please clear the previous results first, directory: \"mln\""
    exit 0;
  fi
fi

numOfCores || Cores=$(($?/2))

idx=0
for name in `ls $SRC_CAVIAR`; do
 if [ -d $SRC_CAVIAR"/"${name} ]; then
  dir_names_1[${idx}]=${name}
  idx=$((${idx}+1))
 fi
done


CurrStart=0
End=$((${#dir_names_1[@]}))
Step=$((($End/$Cores)-1))

for i in `seq 1 $Cores`; do
  currList=""
  if [ $i -ne "${Cores}" ]; then
    CurrEnd=$(($CurrStart+$Step))
    for j in `seq $CurrStart $CurrEnd`; do
      if [ -z ${currList} ]; then
	currList="'"${dir_names_1[${j}]}"'"
      else
	currList=${currList}",'"${dir_names_1[${j}]}"'"
      fi
    done
    CurrStart=$(($CurrEnd+1))
   else
    TheEnd=$(($End-1))
    for j in `seq $CurrStart $TheEnd`; do
      if [ -z ${currList} ]; then
	currList="'"${dir_names_1[${j}]}"'"
      else
	currList=${currList}",'"${dir_names_1[${j}]}"'"
      fi
    done
  fi
  (execParser "caviar_pair.prolog" $currList &)
done

