#!/bin/bash

#
# ========== Settings ==========
#
x86_64='true'

if [ $x86_64 = 'true' ]; then
  LOCAL_STACK=256m
  GLOBAL_STACK=512m
else
  LOCAL_STACK=128m
  GLOBAL_STACK=128m
fi

SOURCE_DATASET="../source"
SRC_CAVIAR=$SOURCE_DATASET"/caviar"
TRG_CAVIAR="./mln/caviar"

echo "SOURCE_DATASET="$SOURCE_DATASET
echo "SRC_CAVIAR="$SRC_CAVIAR
echo "SRC_CAVIAR_ABRUPT="$SRC_CAVIAR_ABRUPT
# =============================



if [ ! -d "./mln" ]; then
  mkdir "./mln"
  mkdir "./mln/caviar"
else
  list=`ls ./mln`
  if [ -n "${list}" ]; then
    echo "Please delete the previous results first, directory: \"mln\""
    exit 0;
  fi
fi


idx=0
for name in `ls $SRC_CAVIAR`; do
 if [ -d $SRC_CAVIAR"/"${name} ]; then
  dir_names_1[${idx}]=${name}
  idx=$((${idx}+1))
 fi
done

# list of directory names
currList=""
lastIdx=$((${#dir_names_1[@]} - 1))

for j in `seq 0 $lastIdx`; do
  if [ -z ${currList} ]; then
    currList="'"${dir_names_1[${j}]}"'"
  else
    currList=${currList}",'"${dir_names_1[${j}]}"'"
  fi
done
  
echo "Executing: prolog -f caviar_pair.prolog -t \"make([$currList]).\""
nice prolog -f caviar.prolog -t "make([$currList])."
